SET DEFINE OFF
--
-- 
-- ___________________________________________________________________
--  /!\ ATTENTION /!\  fichier encodé en UTF-8   (  il peut  contenir des é è ç à î ê ô ... )
-- ___________________________________________________________________
--
--
-- 
-- Fichier :  n°2/5
-- Type : DDL
-- Schéma modifié :  STAGES
-- Schéma d'execution du script : STAGES
-- Numéro de version :  0.5.0.0
-- Date de publication : 11/02/2013
-- Licence : CeCILL version 2
--
--

/**
 * Création initiale des tables  
 */

whenever sqlerror exit sql.sqlcode ;

/**
 * STAGES.DB_VERSION 
 */
CREATE TABLE STAGES.DB_VERSION 
    ( 
     DBV_ID NUMBER (4)  NOT NULL , 
     DBV_LIBELLE VARCHAR2 (15)  NOT NULL , 
     DBV_DATE DATE  NOT NULL , 
     DBV_INSTALL DATE , 
     DBV_COMMENT VARCHAR2 (2000 BYTE) 
    ) 
;



COMMENT ON TABLE  STAGES.DB_VERSION IS 'Historique des versions du schéma du user STAGES';
COMMENT ON COLUMN STAGES.DB_VERSION.DBV_ID IS 'Identifiant de la version' ;
COMMENT ON COLUMN STAGES.DB_VERSION.DBV_LIBELLE IS 'Libelle de la version' ;
COMMENT ON COLUMN STAGES.DB_VERSION.DBV_DATE IS 'Date de release de la version' ;
COMMENT ON COLUMN STAGES.DB_VERSION.DBV_INSTALL IS 'Date d''installation de la version. Si non renseigné, la version n''est pas complétement installée.' ;
COMMENT ON COLUMN STAGES.DB_VERSION.DBV_COMMENT IS 'Le commentaire : une courte description de cette version de la base de données.' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_DB_VERSION ON STAGES.DB_VERSION ( DBV_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.DB_VERSION ADD CONSTRAINT PK_DB_VERSION PRIMARY KEY ( DBV_ID ) ;

CREATE SEQUENCE STAGES.DB_VERSION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;

-- Ajout d'un DB_VERSION
INSERT INTO STAGES.DB_VERSION VALUES(STAGES.DB_VERSION_SEQ.NEXTVAL, '0.5.0.0', TO_DATE('11/02/2013', 'DD/MM/YYYY'),NULL,'Installation initiale de l''utilisateur STAGES');


/**
 * STAGES.STG_ABSENCE 
 */
CREATE TABLE STAGES.STG_ABSENCE 
    ( 
     SAB_ID NUMBER (12)  NOT NULL , 
     STG_ID NUMBER (12) , 
     MEC_KEY NUMBER (12) , 
     PERS_ID_VALIDE NUMBER (12) , 
     SAB_D_DEBUT DATE  NOT NULL , 
     SAB_D_FIN DATE  NOT NULL , 
     SAB_VALIDE VARCHAR2 (1 BYTE) DEFAULT 'N'  NOT NULL , 
     SAB_DEMIEJOURNEE_DEBUT VARCHAR2 (2 BYTE)  NOT NULL , 
     SAB_DEMIEJOURNEE_FIN VARCHAR2 (2 BYTE)  NOT NULL , 
     SAB_COMMENTAIRE VARCHAR2 (200) 
    ) 
;



COMMENT ON TABLE STAGES.STG_ABSENCE IS 'Liste des absences de l''étudiant pendant son stage, définies soient au niveau de l''EC, soit au niveau du stage lui-même';
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_ID IS 'Clé primaine de la table absence' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.STG_ID IS 'Clé primaire du stage, si l''absence est directement rattachee a un stage' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.PERS_ID_VALIDE IS 'Identifiant de la personne qui a valide l''absence' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_D_DEBUT IS 'Date de début de l''absence' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_D_FIN IS 'Date de fin de l''absence' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_VALIDE IS 'Indique si l''absence est validée ou non ("O","N")' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_DEMIEJOURNEE_DEBUT IS 'Indique si l''absence début le matin ou l''après-midi ("am","pm")' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_DEMIEJOURNEE_FIN IS 'Indique si l''absence finit le matin ou l''après-midi ("am","pm")' ;
COMMENT ON COLUMN STAGES.STG_ABSENCE.SAB_COMMENTAIRE IS 'Commentaire sur l''absence' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_ABSENCE ON STAGES.STG_ABSENCE ( SAB_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_ABSENCE ADD CONSTRAINT PK_STG_ABSENCE PRIMARY KEY ( SAB_ID ) ;


/**
 * STAGES.STG_ACCES 
 */
CREATE TABLE STAGES.STG_ACCES 
    ( 
     SAC_ID NUMBER (12)  NOT NULL , 
     SAC_LC VARCHAR2 (5 BYTE)  NOT NULL , 
     SAC_LL VARCHAR2 (50 BYTE)  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_ACCES IS 'Table de nomenclature des différentes méthodes d''accès possible aux stages (candidature spontanée, offre sur le site de l''établissement, ...)';
COMMENT ON COLUMN STAGES.STG_ACCES.SAC_ID IS 'Clé primaire de la table d''accès' ;
COMMENT ON COLUMN STAGES.STG_ACCES.SAC_LC IS 'Libellé court de l''accès' ;
COMMENT ON COLUMN STAGES.STG_ACCES.SAC_LL IS 'Libellé long de l''accès' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_ACCES ON STAGES.STG_ACCES ( SAC_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SAC_LC ON STAGES.STG_ACCES ( SAC_LC ASC ) TABLESPACE SCOL_INDX;

ALTER TABLE STAGES.STG_ACCES ADD CONSTRAINT PK_STG_ACCES PRIMARY KEY ( SAC_ID );
ALTER TABLE STAGES.STG_ACCES ADD CONSTRAINT UK_SAC_LC UNIQUE ( SAC_LC );


/**
 * STAGES.STG_ADRESSE 
 */
CREATE TABLE STAGES.STG_ADRESSE 
    ( 
     SADR_ID NUMBER (12)  NOT NULL , 
     STG_ID NUMBER (12)  NOT NULL , 
     ADR_ORDRE NUMBER  NOT NULL , 
     SADR_TEM_DEPLACEMENT VARCHAR2 (1 BYTE)  NOT NULL , 
     SADR_COMMENTAIRE VARCHAR2 (2000 BYTE) 
    ) 
;



COMMENT ON TABLE STAGES.STG_ADRESSE IS 'Adresse du lieu du stage, dans le cas où il serait différent de l''adresse de l''organisme d''accueil';
COMMENT ON COLUMN STAGES.STG_ADRESSE.SADR_ID IS 'Identifiant de l''adresse' ;
COMMENT ON COLUMN STAGES.STG_ADRESSE.ADR_ORDRE IS 'Identifiant de l''adresse dabs GRHUM.ADRESSE' ;
COMMENT ON COLUMN STAGES.STG_ADRESSE.SADR_TEM_DEPLACEMENT IS 'Indique si c''est une adresse où l''étudiant aura à se déplacer (''O'') ou si c''est l''adresse du lieu du stage (''N'')' ;
COMMENT ON COLUMN STAGES.STG_ADRESSE.SADR_COMMENTAIRE IS 'Commentaire sur l''adresse' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_ADRESSE ON STAGES.STG_ADRESSE ( SADR_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_ADRESSE ADD CONSTRAINT PK_STG_ADRESSE PRIMARY KEY ( SADR_ID );


/**
 * STAGES.STG_ANNEE 
 */
CREATE TABLE STAGES.STG_ANNEE 
    ( 
     SAN_ID NUMBER (4)  NOT NULL , 
     SAN_DEBUT NUMBER (4)  NOT NULL , 
     SAN_FIN NUMBER (4)  NOT NULL , 
     SAN_COURANTE VARCHAR2 (1 BYTE) DEFAULT 'N'  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_ANNEE IS 'Définition des années ';
COMMENT ON COLUMN STAGES.STG_ANNEE.SAN_ID IS 'Clé primaire de l''année' ;
COMMENT ON COLUMN STAGES.STG_ANNEE.SAN_DEBUT IS 'Début de l''année universitaire' ;
COMMENT ON COLUMN STAGES.STG_ANNEE.SAN_FIN IS 'Fin de l''année universitaire' ;
COMMENT ON COLUMN STAGES.STG_ANNEE.SAN_COURANTE IS 'Indique si c''est l''année courante ("O","N")' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_ANNEE ON STAGES.STG_ANNEE ( SAN_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_ANNEE ADD CONSTRAINT PK_STG_ANNEE PRIMARY KEY ( SAN_ID );


/**
 * STAGES.STG_AVENANT 
 */
CREATE TABLE STAGES.STG_AVENANT 
    ( 
     SAV_ID NUMBER (12)  NOT NULL , 
     STG_ID NUMBER (12)  NOT NULL , 
     AVT_ORDRE NUMBER (38)  NOT NULL , 
     PERS_ID_CREATION NUMBER (12)  NOT NULL , 
     PERS_ID_MODIFICATION NUMBER (12)  NOT NULL , 
     PERS_ID_VALIDATION NUMBER (12) , 
     PERS_ID_VERROUILLAGE NUMBER(12, 0),
     PERS_ID_SUPPRESSION NUMBER(12, 0),
     SAV_LIEU_ADR_ORDRE NUMBER (12) , 
     SAV_D_CREATION DATE  NOT NULL , 
     SAV_D_MODIFICATION DATE  NOT NULL , 
     SAV_D_VALIDATION DATE , 
     SAV_D_VERROUILLAGE DATE ,
     SAV_D_SUPPRESSION DATE,
     SAV_VALIDE VARCHAR2(1 BYTE),
     SAV_D_STAGE_DEBUT DATE , 
     SAV_D_STAGE_FIN DATE , 
     SAV_D_INTER_DEBUT DATE , 
     SAV_D_INTER_FIN DATE , 
     SAV_D_DEPLAC_DEBUT DATE , 
     SAV_D_DEPLAC_FIN DATE,  
     SAV_SUJET VARCHAR2(2000 BYTE)
    )
;




COMMENT ON TABLE STAGES.STG_AVENANT IS 'Table des avenants';
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_ID IS 'Clé primaire de l''avenant' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.STG_ID IS 'Clé primaire du stage' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.AVT_ORDRE IS 'Clé étrangère vers la table ACCORDS.AVENANT ' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.PERS_ID_CREATION IS 'Pers_id du créateur de l''avenant' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.PERS_ID_MODIFICATION IS 'Pers_id de la dernière personne a avoir modifié l''avenant' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.PERS_ID_VALIDATION IS 'Pers_id de la personne qui a validé l''avenant' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_LIEU_ADR_ORDRE IS 'Clé étrangère vers la table adresse pour le nouveau lieu du stage' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_CREATION IS 'Date de création de l''avenant' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_MODIFICATION IS 'Date de la dernière modification' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_VALIDATION IS 'Date de validation de l''avenant' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_STAGE_DEBUT IS 'Nouvelle date de début du stage' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_STAGE_FIN IS 'Nouvelle date de fin du stage' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_INTER_DEBUT IS 'Date de début d''interruption' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_INTER_FIN IS 'Date de fin d''interruption' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_DEPLAC_DEBUT IS 'Date de début de déplacement' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_DEPLAC_FIN IS 'Date de fin de déplacement' ;
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_SUJET IS 'Un nouveau sujet de stage';
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_SUPPRESSION IS 'Date de suppression';
COMMENT ON COLUMN STAGES.STG_AVENANT.PERS_ID_SUPPRESSION IS 'Pers_id de la personne qui a supprimé l''avenant';
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_VALIDE IS 'Indique si l''avenant est valide (''O'', ''N'')';
COMMENT ON COLUMN STAGES.STG_AVENANT.PERS_ID_VERROUILLAGE IS 'Pers_id de la personne qui a verrouillé l''avenant';
COMMENT ON COLUMN STAGES.STG_AVENANT.SAV_D_VERROUILLAGE IS 'Date de verrouillage';

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_AVENANT ON STAGES.STG_AVENANT ( SAV_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_AVENANT ADD CONSTRAINT PK_STG_AVENANT PRIMARY KEY ( SAV_ID );


/**
 * STAGES.STG_CONFIG 
 */
CREATE TABLE STAGES.STG_CONFIG 
    ( 
     SCFG_ID NUMBER (12)  NOT NULL , 
     MEC_KEY NUMBER (12) , 
     SCFG_LC VARCHAR2 (50 BYTE)  NOT NULL , 
     SCFG_VALEUR VARCHAR2 (2000 BYTE)  NOT NULL , 
     SCFG_VALEUR_COMPLEMENT VARCHAR2 (2000 BYTE) 
    ) 
;



COMMENT ON TABLE STAGES.STG_CONFIG IS 'Table de configuration de l''application et des EC';
COMMENT ON COLUMN STAGES.STG_CONFIG.SCFG_ID IS 'Clé primaine de la table de configuration' ;
COMMENT ON COLUMN STAGES.STG_CONFIG.SCFG_LC IS 'Libellé permettant d''indentifier la variabe de configuration' ;
COMMENT ON COLUMN STAGES.STG_CONFIG.SCFG_VALEUR IS 'Valeur de la variable de configuration' ;
COMMENT ON COLUMN STAGES.STG_CONFIG.SCFG_VALEUR_COMPLEMENT IS 'Complément à la valeur de la variable' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_CONFIG ON STAGES.STG_CONFIG ( SCFG_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_CONFIG ADD CONSTRAINT PK_STG_CONFIG PRIMARY KEY ( SCFG_ID );


/**
 * STAGES.STG_DOMAINE 
 */
CREATE TABLE STAGES.STG_DOMAINE 
    ( 
     SDOM_ID NUMBER (12)  NOT NULL , 
     SDOM_LC VARCHAR2 (5 BYTE)  NOT NULL , 
     SDOM_LL VARCHAR2 (50 BYTE)  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_DOMAINE IS 'Table de nomenclature des domaines';
COMMENT ON COLUMN STAGES.STG_DOMAINE.SDOM_ID IS 'Clé primaine de la table de domaines' ;
COMMENT ON COLUMN STAGES.STG_DOMAINE.SDOM_LC IS 'Libellé court du domaine' ;
COMMENT ON COLUMN STAGES.STG_DOMAINE.SDOM_LL IS 'Libellé long du domaine' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_DOMAINE ON STAGES.STG_DOMAINE ( SDOM_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SDOM_LC ON STAGES.STG_DOMAINE ( SDOM_LC ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_DOMAINE ADD CONSTRAINT PK_STG_DOMAINE PRIMARY KEY ( SDOM_ID );
ALTER TABLE STAGES.STG_DOMAINE ADD CONSTRAINT UK_SDOM_LC UNIQUE ( SDOM_LC );


/**
 * STAGES.STG_ETAT 
 */
CREATE TABLE STAGES.STG_ETAT 
    ( 
     SET_ID NUMBER (12)  NOT NULL , 
     SET_ORDRE NUMBER (2)  NOT NULL , 
     SET_LC VARCHAR2 (5 BYTE)  NOT NULL , 
     SET_LL VARCHAR2 (100 BYTE)  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_ETAT IS 'Table de nomenclature des différents états de la convention ';
COMMENT ON COLUMN STAGES.STG_ETAT.SET_ID IS 'Clé primaire de la table d''états' ;
COMMENT ON COLUMN STAGES.STG_ETAT.SET_ORDRE IS 'Numéro d''ordre de l''état (de 0 à n)' ;
COMMENT ON COLUMN STAGES.STG_ETAT.SET_LC IS 'Libellé court de l''état' ;
COMMENT ON COLUMN STAGES.STG_ETAT.SET_LL IS 'Libellé long de l''état' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_ETAT ON STAGES.STG_ETAT ( SET_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SET_LC ON STAGES.STG_ETAT ( SET_LC ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SET_ORDRE ON STAGES.STG_ETAT ( SET_ORDRE ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_ETAT ADD CONSTRAINT PK_STG_ETAT PRIMARY KEY ( SET_ID );
ALTER TABLE STAGES.STG_ETAT ADD CONSTRAINT UK_SET_LC UNIQUE ( SET_LC );
ALTER TABLE STAGES.STG_ETAT ADD CONSTRAINT UK_SET_ORDRE UNIQUE ( SET_ORDRE );


/**
 * STAGES.STG_EVENEMENT 
 */
CREATE TABLE STAGES.STG_EVENEMENT 
    ( 
     SEV_ID NUMBER (12)  NOT NULL , 
     SEVT_ID NUMBER (12)  NOT NULL , 
     STG_ID NUMBER (12)  NOT NULL , 
     PERS_ID_CREATEUR NUMBER (12)  NOT NULL , 
     SEV_D_CREATION DATE  NOT NULL , 
     SEV_D_DEBUT DATE , 
     SEV_D_FIN DATE , 
     SEV_COMMENTAIRE VARCHAR2 (2000 BYTE) 
    ) 
;



COMMENT ON TABLE STAGES.STG_EVENEMENT IS 'Table des évènements relatifs au stage et à la convention';
COMMENT ON COLUMN STAGES.STG_EVENEMENT.SEV_ID IS 'Clé primaire de la table d''évènements' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.SEVT_ID IS 'Clé primaire de la table de type d''évènement' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.STG_ID IS 'Clé primaire du stage' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.PERS_ID_CREATEUR IS 'Pers_id de l''utilisateur ayant provoqué l''évènement' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.SEV_D_CREATION IS 'Date de création de l''évènement' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.SEV_D_DEBUT IS 'date de début de l''évènement (si différé)' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.SEV_D_FIN IS 'Date de fin de l''évènement (si connue)' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT.SEV_COMMENTAIRE IS 'Commentaire sur l''évènement' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_EVENEMENT ON STAGES.STG_EVENEMENT ( SEV_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_EVENEMENT ADD CONSTRAINT PK_STG_EVENEMENT PRIMARY KEY ( SEV_ID );


/**
 * STAGES.STG_EVENEMENT_TYPE 
 */
CREATE TABLE STAGES.STG_EVENEMENT_TYPE 
    ( 
     SEVT_ID NUMBER (12)  NOT NULL , 
     SEVT_LL VARCHAR2 (50 BYTE) , 
     SEVT_LC VARCHAR2 (5 BYTE) 
    ) 
;



COMMENT ON TABLE STAGES.STG_EVENEMENT_TYPE IS 'Table de nomenclature des types d''évènements';
COMMENT ON COLUMN STAGES.STG_EVENEMENT_TYPE.SEVT_ID IS 'Clé primaire de la table de type d''évènement' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT_TYPE.SEVT_LL IS 'Libellé long du type d''évènement' ;
COMMENT ON COLUMN STAGES.STG_EVENEMENT_TYPE.SEVT_LC IS 'Libellé court du type d''évènement' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_EVENEMENT_TYPE ON STAGES.STG_EVENEMENT_TYPE ( SEVT_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SEVT_LC ON STAGES.STG_EVENEMENT_TYPE ( SEVT_LC ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_EVENEMENT_TYPE ADD CONSTRAINT PK_STG_EVENEMENT_TYPE PRIMARY KEY ( SEVT_ID );
ALTER TABLE STAGES.STG_EVENEMENT_TYPE ADD CONSTRAINT UK_SEVT_LC UNIQUE ( SEVT_LC );


/**
 * STAGES.STG_PIECE_JOINTE_CONFIG 
 */
CREATE TABLE STAGES.STG_PIECE_JOINTE_CONFIG 
    ( 
     SPJC_ID NUMBER (12)  NOT NULL , 
     STY_ID NUMBER (12)  NOT NULL , 
     SPJT_ID NUMBER (12)  NOT NULL , 
     SPJC_OBLIGATOIRE VARCHAR2 (1 BYTE) DEFAULT 'N'  NOT NULL , 
     SPJC_OBLIGATOIRE_ETRANGER VARCHAR2 (1 BYTE) DEFAULT 'N'  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_PIECE_JOINTE_CONFIG IS 'Liste des pièces jointes pouvant être associées à un stage, par type de stage';
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_CONFIG.SPJC_ID IS 'Clé primaire de la table pièce jointe' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_CONFIG.STY_ID IS 'Clé primaire du type de stage' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_CONFIG.SPJT_ID IS 'Clé primaire des types de pièces jointes' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_CONFIG.SPJC_OBLIGATOIRE IS 'Indique si la pièce jointe est obligatoire ou non (''O'',''N'')' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_CONFIG.SPJC_OBLIGATOIRE_ETRANGER IS 'Indique si la pièce jointe est obligatoire ou non (''O'',''N'') pour les stages à l''étranger' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_PIECE_JOINTE_CONFIG ON STAGES.STG_PIECE_JOINTE_CONFIG ( SPJC_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_PIECE_JOINTE_CONFIG ADD CONSTRAINT PK_STG_PIECE_JOINTE_CONFIG PRIMARY KEY ( SPJC_ID );


/**
 * STAGES.STG_PIECE_JOINTE_REPART 
 */
CREATE TABLE STAGES.STG_PIECE_JOINTE_REPART 
    ( 
     SPJR_ID NUMBER (12)  NOT NULL , 
     SPJT_ID NUMBER (12)  NOT NULL , 
     STG_ID NUMBER (12)  NOT NULL , 
     SPJR_PERS_ID NUMBER (12)  NOT NULL , 
     SPJR_FICHIER_ID NUMBER (12) , 
     SPJR_D_CREATION DATE  NOT NULL , 
     SPJR_VERSION_PAPIER VARCHAR2 (1 BYTE) DEFAULT 'N'  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_PIECE_JOINTE_REPART IS 'Table de répartition des pièces jointes déposées pour un stage';
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.SPJR_ID IS 'Clé primaine de la table de répartition des pièces jointes' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.SPJT_ID IS 'Clé primaire des types de pièces jointes' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.STG_ID IS 'Clé primaire du stage' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.SPJR_PERS_ID IS 'Identifiant du créateur de la pièce jointe' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.SPJR_FICHIER_ID IS 'Identifiant du fichier dans la GED' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.SPJR_D_CREATION IS 'Date de création de la pièce jointe' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_REPART.SPJR_VERSION_PAPIER IS 'Indique si la pièce jointe a été fournie en version non numérique (''O'',''N'')' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_PIECE_JOINTE_REPART ON STAGES.STG_PIECE_JOINTE_REPART ( SPJR_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_PIECE_JOINTE_REPART ADD CONSTRAINT PK_STG_PIECE_JOINTE_REPART PRIMARY KEY ( SPJR_ID );


/**
 * STAGES.STG_PIECE_JOINTE_TYPE 
 */
CREATE TABLE STAGES.STG_PIECE_JOINTE_TYPE 
    ( 
     SPJT_ID NUMBER (12)  NOT NULL , 
     SPJT_LC VARCHAR2 (5 BYTE)  NOT NULL , 
     SPJT_LL VARCHAR2 (50 BYTE)  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_PIECE_JOINTE_TYPE IS 'Nomenclature des types de pièces jointes';
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_TYPE.SPJT_ID IS 'Clé primaire des types de pièces jointes' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_TYPE.SPJT_LC IS 'Libellé court du type de pièce jointe' ;
COMMENT ON COLUMN STAGES.STG_PIECE_JOINTE_TYPE.SPJT_LL IS 'Liellé long du type de pièce jointe' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STAGE_PIECE_JOINTE_TYPE ON STAGES.STG_PIECE_JOINTE_TYPE ( SPJT_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SPJT_LC ON STAGES.STG_PIECE_JOINTE_TYPE ( SPJT_LC ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_PIECE_JOINTE_TYPE ADD CONSTRAINT PK_STAGE_PIECE_JOINTE_TYPE PRIMARY KEY ( SPJT_ID );
ALTER TABLE STAGES.STG_PIECE_JOINTE_TYPE ADD CONSTRAINT UK_SPJT_LC UNIQUE ( SPJT_LC );


/**
 * STAGES.STG_REPART_DOMAINE 
 */
CREATE TABLE STAGES.STG_REPART_DOMAINE 
    ( 
     SRDOM_ID NUMBER (12)  NOT NULL , 
     SDOM_ID NUMBER (12)  NOT NULL , 
     STG_ID NUMBER (12)  NOT NULL 
    ) 
;



COMMENT ON TABLE STAGES.STG_REPART_DOMAINE IS 'Table de répartition des domaines de stage';
COMMENT ON COLUMN STAGES.STG_REPART_DOMAINE.SRDOM_ID IS 'Clé primaire de la table de répartition stage-domaine' ;
COMMENT ON COLUMN STAGES.STG_REPART_DOMAINE.SDOM_ID IS 'Clé primaine de la table de domaines' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_REPART_DOMAINE ON STAGES.STG_REPART_DOMAINE ( SRDOM_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_SRDOM_STG_ID ON STAGES.STG_REPART_DOMAINE ( SDOM_ID ASC , STG_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_REPART_DOMAINE ADD CONSTRAINT PK_STG_REPART_DOMAINE PRIMARY KEY ( SRDOM_ID );
ALTER TABLE STAGES.STG_REPART_DOMAINE ADD CONSTRAINT UK_SRDOM_STG_ID UNIQUE ( SDOM_ID , STG_ID );


/**
 * STAGES.STG_STAGE 
 */
CREATE TABLE STAGES.STG_STAGE 
    ( 
     STG_ID NUMBER (12)  NOT NULL , 
     STY_ID NUMBER (12)  NOT NULL , 
     OFFRE_ID VARCHAR2 (12 BYTE) , 
     CON_ORDRE NUMBER  NOT NULL , 
     SAN_ID NUMBER (4)  NOT NULL , 
     MEC_KEY NUMBER (12) , 
     SAC_ID NUMBER (12)  NOT NULL , 
     SET_ID NUMBER (12)  NOT NULL , 
     NUM_ETUDIANT NUMBER (12)  NOT NULL , 
     ADR_ETU_ORDRE NUMBER  NOT NULL ,
     PERS_ID_TUTEUR NUMBER (12) , 
     PERS_ID_ENCADRANT NUMBER (12) , 
     C_STRUCTURE_ACCUEIL NUMBER (12)  NOT NULL , 
     ADR_STRUCTURE_ACCUEIL NUMBER (12),
     C_STRUCTURE_SERVICE NUMBER (12) , 
     ADR_SERVICE_ACCUEIL NUMBER (12),
     CONV_SPECIFIQUE VARCHAR2(1 BYTE) DEFAULT 'N' NOT NULL,
     STG_DUREE_TOTALE_VAL NUMBER (4)  NOT NULL , 
     STG_DUREE_TOTALE_UNITE VARCHAR2 (1)  NOT NULL , 
     STG_NB_JOURS_HEBDO NUMBER (1)  NOT NULL , 
     STG_DUREE_HEBDO NUMBER (4)  NOT NULL , 
     STG_DUREE_QUOTIDIENNE NUMBER (4) , 
     STG_DUREE_AM NUMBER (4) , 
     STG_DUREE_PM NUMBER (4) , 
     STG_D_DEBUT DATE  NOT NULL , 
     STG_D_FIN DATE  NOT NULL , 
     STG_D_CREATION DATE  NOT NULL , 
     STG_D_MODIFICATION DATE  NOT NULL , 
     STG_D_SUPPRESSION DATE , 
     STG_GRAT_MODE_VERSEMENT NUMBER (12) , 
     STG_GRAT_MONTANT NUMBER (15,2) , 
     STG_GRAT_DEVISE VARCHAR2 (3 BYTE) , 
     STG_GRAT_OBLIGATOIRE VARCHAR2 (1 BYTE)  NOT NULL , 
     STG_GRAT_MENSUELLE VARCHAR2 (1 BYTE) , 
     STG_LANGUE VARCHAR2 (2 BYTE) DEFAULT 'fr'  NOT NULL , 
     STG_HORAIRES VARCHAR2 (200 BYTE) , 
     STT_JOURS_NON_OUVRES VARCHAR2 (200 BYTE) , 
     STG_SUJET VARCHAR2 (2000 BYTE)  NOT NULL , 
     STG_SUJET_PEDAGOGIQUE VARCHAR2 (2000 BYTE) , 
     STG_ACTIVITES VARCHAR2 (2000 BYTE) , 
     STG_DUREE_TOTALE_COMMENTAIRE VARCHAR2 (2000 BYTE) , 
     STG_GRAT_AVANTAGES VARCHAR2 (2000 BYTE) 
    ) 
;




COMMENT ON TABLE STAGES.STG_STAGE IS 'Table des stages';
COMMENT ON COLUMN STAGES.STG_STAGE.STG_ID IS 'Clé primaire du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STY_ID IS 'Clé primaire du type de stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.OFFRE_ID IS 'Clé étrangère vers la table des offres, ou champs texte simple si les offres de stages sont externalisées' ;
COMMENT ON COLUMN STAGES.STG_STAGE.CON_ORDRE IS 'Clé étrangère vers le contrat (ACCORDS)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.SAN_ID IS 'Clé primaire de l''année' ;
COMMENT ON COLUMN STAGES.STG_STAGE.SAC_ID IS 'Clé primaire de la table d''accès' ;
COMMENT ON COLUMN STAGES.STG_STAGE.SET_ID IS 'Clé primaire de la table d''états' ;
COMMENT ON COLUMN STAGES.STG_STAGE.NUM_ETUDIANT IS 'Identifiant de l''étudiant' ;
COMMENT ON COLUMN STAGES.STG_STAGE.ADR_ETU_ORDRE IS 'Identifiant de l''adresse de l''étudiant apparaissant sur la convention' ;
COMMENT ON COLUMN STAGES.STG_STAGE.PERS_ID_TUTEUR IS 'Identifiant du tuteur' ;
COMMENT ON COLUMN STAGES.STG_STAGE.PERS_ID_ENCADRANT IS 'Identifiant de l''encadrant au sein de la structure d''accueil' ;
COMMENT ON COLUMN STAGES.STG_STAGE.C_STRUCTURE_ACCUEIL IS 'Identifiant de la structure d''accueil (GRHUM.STRUCTURE_ULR)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.ADR_STRUCTURE_ACCUEIL IS 'Identifiant de l''adresse de la structure d''accueil apparaissant sur la convention';
COMMENT ON COLUMN STAGES.STG_STAGE.C_STRUCTURE_SERVICE IS 'Identifiant du service où se déroule le stage (GRHUM.STRUCTURE_ULR ayant pour père la structure d''accueil)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.ADR_SERVICE_ACCUEIL IS 'Identifiant de l''adresse du service de la structure d''accueil apparaissant sur la convention';
COMMENT ON COLUMN STAGES.STG_STAGE.CONV_SPECIFIQUE IS 'Indique si on est dans le cadre d''une convention specifique';
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_TOTALE_VAL IS 'Valeur de la durée totale du stage, sans l''unité' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_TOTALE_UNITE IS 'Unite de la durée totale du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_NB_JOURS_HEBDO IS 'Nombre de jours de présence par semaine' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_HEBDO IS 'Duree de présence par semaine (en minutes)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_QUOTIDIENNE IS 'Nombre de minutes de presence, pour chaque jour (les jours sont séparés par des virgules)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_AM IS 'Nombre de minutes de présence, pour chaque matinée (les jours sont séparés par des virgules)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_PM IS 'Nombre de minutes de présence, pour chaque après-midi (les jours sont séparés par des virgules)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_D_DEBUT IS 'Date de début du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_D_FIN IS 'Date de fin du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_D_CREATION IS 'Date de création' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_D_MODIFICATION IS 'Date de dernière modification' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_D_SUPPRESSION IS 'Date de suppression du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_GRAT_MODE_VERSEMENT IS 'Identifiant du mode de versement de la gratification (V_MODE_VERSEMENT)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_GRAT_MONTANT IS 'Montant de la gratification' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_GRAT_DEVISE IS 'Identifiant de la devise de la gratification (V_DEVISE)' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_GRAT_OBLIGATOIRE IS 'Inique si la gratification est obligatoire' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_LANGUE IS 'Langue d''édition de la convention - Clé étrangère vers la table LANGUE' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_HORAIRES IS 'Définition des horaires sur une semaine pour chaque jour (séparateurs : jour=";" - am/pm="," - debut/fin="|")' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STT_JOURS_NON_OUVRES IS 'Indique si le stagiaire est présent lors de jours non ouvrés, la nuit, etc...,  et la raison de sa présence' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_SUJET IS 'Sujet du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_SUJET_PEDAGOGIQUE IS 'Sujet pédagogique du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_ACTIVITES IS 'Activités pendant le stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_DUREE_TOTALE_COMMENTAIRE IS 'Précisions sur la durée du stage' ;
COMMENT ON COLUMN STAGES.STG_STAGE.STG_GRAT_AVANTAGES IS 'Liste des avantages en nature ou en espèce' ;

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_STAGE ON STAGES.STG_STAGE ( STG_ID ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_STAGE ADD CONSTRAINT PK_STG_STAGE PRIMARY KEY ( STG_ID );


/**
 * STAGES.STG_TYPE 
 */
CREATE TABLE STAGES.STG_TYPE 
    ( 
     STY_ID NUMBER (12)  NOT NULL , 
     STY_LC VARCHAR2 (5 BYTE)  NOT NULL , 
     STY_LL VARCHAR2 (60 BYTE)  NOT NULL , 
     STY_AFFICHAGE VARCHAR2 (200 BYTE)  NOT NULL , 
     STY_MODELE_CONV VARCHAR2 (50 BYTE)  NOT NULL , 
     STY_MODELE_LETTRE VARCHAR2 (50 BYTE),
     STY_EC_OBLIGATOIRE VARCHAR2 (1 BYTE) DEFAULT 'N' NOT NULL
    ) 
;


COMMENT ON TABLE STAGES.STG_TYPE IS 'Table de nomenclature des types de stage';
COMMENT ON COLUMN STAGES.STG_TYPE.STY_ID IS 'Clé primaire du type de stage' ;
COMMENT ON COLUMN STAGES.STG_TYPE.STY_LC IS 'Libellé court du type de stage' ;
COMMENT ON COLUMN STAGES.STG_TYPE.STY_LL IS 'Libellé long du type de stage' ;
COMMENT ON COLUMN STAGES.STG_TYPE.STY_AFFICHAGE IS 'Libellé long du type de stage pour affichage sur la convention' ;
COMMENT ON COLUMN STAGES.STG_TYPE.STY_MODELE_CONV IS 'Nom du modéle de convention (sans référence à la langue)' ;
COMMENT ON COLUMN STAGES.STG_TYPE.STY_MODELE_LETTRE IS 'Nom du modèle de lettre d''accompagnement à la convention (sans référence à la langue)' ;
COMMENT ON COLUMN STAGES.STG_TYPE.STY_EC_OBLIGATOIRE IS 'Indique si ce type de stage doit être lié à un EC (O : oui, N : non, I : oui ou non)';

CREATE UNIQUE INDEX STAGES.IDX_PK_STG_TYPE ON STAGES.STG_TYPE ( STY_ID ASC ) TABLESPACE SCOL_INDX;
CREATE UNIQUE INDEX STAGES.IDX_UK_STY_LC ON STAGES.STG_TYPE ( STY_LC ASC ) TABLESPACE SCOL_INDX;
ALTER TABLE STAGES.STG_TYPE ADD CONSTRAINT PK_STG_TYPE PRIMARY KEY ( STY_ID );
ALTER TABLE STAGES.STG_TYPE ADD CONSTRAINT UK_STY_LC UNIQUE ( STY_LC );

-- -- --
-- FK --
-- -- --
ALTER TABLE STAGES.STG_CONFIG  ADD CONSTRAINT CONFIG_TO_MEC FOREIGN KEY ( MEC_KEY )  REFERENCES SCOLARITE.SCOL_MAQUETTE_EC ( MEC_KEY ) ON DELETE SET NULL;
ALTER TABLE STAGES.STG_ABSENCE ADD CONSTRAINT ABSENCE_TO_MEC FOREIGN KEY ( MEC_KEY ) REFERENCES SCOLARITE.SCOL_MAQUETTE_EC ( MEC_KEY ) ON DELETE SET NULL;
ALTER TABLE STAGES.STG_ABSENCE ADD CONSTRAINT STAGE_TO_ABSENCES FOREIGN KEY ( STG_ID ) REFERENCES STAGES.STG_STAGE ( STG_ID ) ON DELETE SET NULL;
ALTER TABLE STAGES.STG_STAGE ADD CONSTRAINT STAGE_TO_MEC FOREIGN KEY ( MEC_KEY ) REFERENCES SCOLARITE.SCOL_MAQUETTE_EC ( MEC_KEY ) ON DELETE SET NULL;
ALTER TABLE STAGES.STG_STAGE ADD CONSTRAINT STAGE_TO_STAGE_TYPE FOREIGN KEY ( STY_ID ) REFERENCES STAGES.STG_TYPE ( STY_ID );
ALTER TABLE STAGES.STG_STAGE ADD CONSTRAINT STAGE_TO_ACCES FOREIGN KEY ( SAC_ID ) REFERENCES STAGES.STG_ACCES ( SAC_ID );
ALTER TABLE STAGES.STG_STAGE ADD CONSTRAINT STAGE_TO_ANNEE FOREIGN KEY ( SAN_ID ) REFERENCES STAGES.STG_ANNEE ( SAN_ID );
ALTER TABLE STAGES.STG_STAGE ADD CONSTRAINT STAGE_TO_ETAT FOREIGN KEY ( SET_ID ) REFERENCES STAGES.STG_ETAT ( SET_ID );
ALTER TABLE STAGES.STG_EVENEMENT ADD CONSTRAINT STAGE_TO_EVENEMENTS FOREIGN KEY ( STG_ID ) REFERENCES STAGES.STG_STAGE ( STG_ID );
ALTER TABLE STAGES.STG_EVENEMENT ADD CONSTRAINT EVENEMENT_TO_TYPE FOREIGN KEY ( SEVT_ID ) REFERENCES STAGES.STG_EVENEMENT_TYPE ( SEVT_ID );
ALTER TABLE STAGES.STG_REPART_DOMAINE ADD CONSTRAINT DOM_TO_REPARTDOM FOREIGN KEY ( SDOM_ID ) REFERENCES STAGES.STG_DOMAINE ( SDOM_ID );
ALTER TABLE STAGES.STG_REPART_DOMAINE ADD CONSTRAINT STAGE_TO_REPARTDOM FOREIGN KEY ( STG_ID ) REFERENCES STAGES.STG_STAGE ( STG_ID );
ALTER TABLE STAGES.STG_ADRESSE ADD CONSTRAINT STAGE_TO_ADRESSE FOREIGN KEY ( STG_ID ) REFERENCES STAGES.STG_STAGE ( STG_ID );
ALTER TABLE STAGES.STG_AVENANT ADD CONSTRAINT STAGE_TO_AVENANT FOREIGN KEY ( STG_ID ) REFERENCES STAGES.STG_STAGE ( STG_ID );
ALTER TABLE STAGES.STG_PIECE_JOINTE_REPART ADD CONSTRAINT STAGE_TO_REPART_PJ FOREIGN KEY ( STG_ID ) REFERENCES STAGES.STG_STAGE ( STG_ID );
ALTER TABLE STAGES.STG_PIECE_JOINTE_CONFIG ADD CONSTRAINT STAGE_TYPE_TO_CONFIG_PJ FOREIGN KEY ( STY_ID ) REFERENCES STAGES.STG_TYPE ( STY_ID );
ALTER TABLE STAGES.STG_PIECE_JOINTE_CONFIG ADD CONSTRAINT TYPE_PJ_TO_CONFIG_PJ FOREIGN KEY ( SPJT_ID ) REFERENCES STAGES.STG_PIECE_JOINTE_TYPE ( SPJT_ID );
ALTER TABLE STAGES.STG_PIECE_JOINTE_REPART ADD CONSTRAINT TYPE_PJ_TO_REPART_PJ FOREIGN KEY ( SPJT_ID ) REFERENCES STAGES.STG_PIECE_JOINTE_TYPE ( SPJT_ID );

-- -------------- --
-- VUE : V_DEVISE --
-- -------------- --
CREATE OR REPLACE VIEW STAGES.V_DEVISE AS 
SELECT
  d.wmo_code as WMO_CODE,
  -- on vire tous les caracteres apres le libelle (tabulations, commentaires, etc..)
  regexp_substr(d.wmo_libelle,'[[:alnum:]]*([[:space:]|[:punct:]]?[[:alnum:]|[:punct:]]+)*') AS LL_DEVISE
FROM
  jefy_mission.web_mon d
WHERE
  d.wmo_code IN
  (
    SELECT
      UNIQUE m.wmo_code
    FROM
      JEFY_MISSION.web_miss m
    WHERE
      m.wmi_fin > sysdate
    OR 
      m.wmi_fin IS NULL
  );

COMMENT ON TABLE STAGES.V_DEVISE IS 'Vue sur les devises';

-- ---------------------- --
-- VUE : V_MODE_VERSEMENT --
-- ---------------------- --
CREATE OR REPLACE VIEW STAGES.V_MODE_VERSEMENT AS 
SELECT 
  MP.MOD_ORDRE AS MOD_ORDRE, 
  REPLACE(MP.MOD_LIBELLE, 'BANQUE', 'VIREMENT') AS MOD_LIBELLE,
  MP.EXE_ORDRE AS EXE_ORDRE
FROM 
  MARACUJA.MODE_PAIEMENT MP
    JOIN MARACUJA.EXERCICE E 
      ON MP.EXE_ORDRE = E.EXE_ORDRE
WHERE 
        MOD_VALIDITE = 'VALIDE'
AND PCO_NUM_VISA IS NULL
AND PCO_NUM_PAIEMENT IS NOT NULL ;

COMMENT ON TABLE STAGES.V_MODE_VERSEMENT IS 'Vue vers les modes de versement';



-- 
-- SEQUENCES
--
CREATE SEQUENCE STAGES.STG_STAGE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_ABSENCE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_ACCES_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_ADRESSE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_AVENANT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_CONFIG_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_EVENEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_EVENEMENT_TYPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_PIECE_JOINTE_CONFIG_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_PIECE_JOINTE_REPART_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_PIECE_JOINTE_TYPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_REPART_DOMAINE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_TYPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
CREATE SEQUENCE STAGES.STG_ETAT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;
